////////////////////////////////////////////////////////////////////////////
// The is the top module containing the sdram_cntrl, the pn_generators and the fifos
// Modify any signals internal to this block that you deem necessary
// Do not change the interface, PORT names/size, of this module.
// Read through the code and do as the instructions indicate.
// This Verilog code is not functional as certain signals have to be generated
/////////////////////////////////////////////////////////////////////////

module sdram_top (	 
		 RAM_D_IN, 		// to SDRAM
		 RAM_D_OUT,		// to SDRAM
		 RAM_D_EN,		// to SDRAM
		 RAM_CLK,		// to SDRAM
		 RAM_CLKE,		// to SDRAM
		 RAM_DQMH,		// to SDRAM
		 RAM_DQML,		// to SDRAM
		 RAM_CS,		// to SDRAM
		 RAM_RAS,		// to SDRAM
		 RAM_CAS,		// to SDRAM
		 RAM_WE,		// to SDRAM
		 RAM_BA,		// to SDRAM
		 RAM_A,		// to SDRAM
		 CLK_IN, 		//from FPGA
		 RESET_IN,		//from FPGA
		 DEBUG, 		// to pins probe
		 time_sel,		//from dip-switches
		 error_cnt		// counter of no. of errors
		 );
	
   input [31:0] RAM_D_IN;
   output [31:0] RAM_D_OUT;
   output 	 RAM_D_EN;   
   output 	 RAM_CLK;
   output 	 RAM_CLKE;
   output 	 RAM_DQMH;
   output 	 RAM_DQML;
   output 	 RAM_CS;
   output 	 RAM_RAS;
   output 	 RAM_CAS;
   output 	 RAM_WE;
   output [1:0]  RAM_BA;
   output [11:0] RAM_A;
   input 	 CLK_IN;
   input 	 RESET_IN;
   inout [31:0]  DEBUG;
   input [15:0] time_sel;
   output[22:0] 	 error_cnt;

  // signals in sdram_cntrl

  // signals in pn_generators

  //signals in FIFOs

 // counts the number of errors
   wire [31:0] 	DEBUG2;
   wire 	error_next;
   assign clk = CLK_IN;
   assign reset = RESET_IN;
		 
//instantiation of your sdram_cntrl module 

  sdram_cntrl sdram_cntrl_inst(
////////////////////////////////////////////////////////////
////These signals must be present in your sdram_cntrl module	 
		 RAM_D_EN,		// to SDRAM
		 RAM_CLK,		// to SDRAM
		 RAM_CLKE,		// to SDRAM
		 RAM_DQMH,		// to SDRAM
		 RAM_DQML,		// to SDRAM
		 RAM_CS,		// to SDRAM
		 RAM_RAS,		// to SDRAM
		 RAM_CAS,		// to SDRAM
		 RAM_WE,		// to SDRAM
		 RAM_BA,		// to SDRAM
		 RAM_A,		// to SDRAM
		 CLK_IN, 		// from FPGA
		 RESET_IN,		// from FPGA
		 DEBUG2, 		// to pins probe
		 time_sel		// from dip-switches
///////////////////////////////////////////////////////////////////
		// you can add as many signals here as you deem necessary here
		 );
		 
////////////////////////////////////////////////////////////
//instantiate your pn-generators here





////////////////////////////////////////////////////////////
//instantiate your FIFOs here

// you can assign the sinit signal in the FIFOs to reset
assign sinit = reset;




///////////////////////////////////////////////////////////////////////
//Create your error detection circuits here.
// compare the output of the fifo_2 with the output of the pn_gen2. 
// Make sure the pn_gen2 is shifted at the right time.
//Increments error counter when the two values are different. You have to create error_next.
// Output the error counter value 

   counter #(23) error_counter(.OUT(error_cnt), .CLK(clk),
			       .ENABLE(error_next), .RESET(reset));  



//////////////////////////////////////////////////////////////
// assign your debugging pins here
   //assign 	 DEBUG[31:0]  = {d_in_fifor[12:0], wr_fifor, rd_fifow,wr_fifow, rd_fifor, DEBUG2[14:0]};

   
endmodule   